<?php

/**
 * @file
 * Hooks provided by the Lingotek Overrides module.
 */

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Field\FieldDefinitionInterface;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Allows modules to extract translatable content from a field.
 *
 * @param \Drupal\Core\Entity\ContentEntityInterface $entity
 *   The entity.
 * @param \Drupal\Core\Field\FieldItemListInterface $field
 *   The field.
 *
 * @return array
 *   The translatable content.
 */
function hook_lingotek_overrides_content_translation_field_FIELD_TYPE_get_source_data(ContentEntityInterface $entity, FieldItemListInterface $field) {
  return [];
}

/**
 * Allows modules to save translated content to its entity.
 *
 * @param \Drupal\Core\Entity\ContentEntityInterface $entity
 *   The entity.
 * @param string $langcode
 *   The translation's language code.
 * @param \Drupal\Core\Field\FieldDefinitionInterface $field_definition
 *   The field definition.
 * @param array $field_data
 *   The translated content.
 *
 * @return mixed
 *   A measure of success.
 */
function hook_lingotek_overrides_content_translation_field_FIELD_TYPE_save_target_data(ContentEntityInterface $entity, $langcode, FieldDefinitionInterface $field_definition, array $field_data) {
  $count = 0;
  // Just a way to return something, while all data should be saved directly to
  // the $entity object.
  foreach ($field_data as $item) {
    $count++;
  }

  return $count;
}

/**
 * Allows modules to alter the Lingotek form-filter plugins.
 *
 * @param array $info
 *   The array of plugin info.
 */
function hook_lingotek_overrides_form_filter_alter(array &$info) {

}

/**
 * Allows modules to alter the Lingotek form-ield plugins.
 *
 * @param array $info
 *   The array of plugin info.
 */
function hook_lingotek_overrides_form_field_alter(array &$info) {

}

/**
 * Allows modules to alter the Lingotek form-operation plugins.
 *
 * @param array $info
 *   The array of plugin info.
 */
function hook_lingotek_overrides_form_operation_alter(array &$info) {

}

/**
 * Allows modules to alter the Lingotek form-option plugins.
 *
 * @param array $info
 *   The array of plugin info.
 */
function hook_lingotek_overrides_form_option_alter(array &$info) {

}
